
import java.io.File;
import java.io.IOException;
import java.util.Scanner;
import org.chocosolver.solver.*;
import org.chocosolver.solver.variables.*;
import org.chocosolver.solver.constraints.*;


public class GCol {

  
    public static void main(String[] args) throws IOException {
	Scanner sc    = new Scanner(new File(args[0])); // graph file, not in DIMACS format
	int n         = sc.nextInt(); // number of vertices
	int m         = Integer.parseInt(args[1]); // number of colours
	Solver solver = new Solver("graph colouring (GCol)");
	IntVar[] v    = VF.enumeratedArray("v",n,1,m,solver); // n vertices each with m colours

	while (sc.hasNext()){
	    int i = sc.nextInt();
	    int j = sc.nextInt();
	    solver.post(ICF.arithm(v[i],"!=",v[j]));
	}
	sc.close();

	System.out.println(solver.findSolution());

	for (int i=0;i<n;i++) System.out.print(v[i].getValue() +" ");
	System.out.println();
	System.out.println("nodes: " + solver.getMeasures().getNodeCount() +"  "+
                           "cpu: " + solver.getMeasures().getTimeCount());
    }
}

